]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- 'rpm -q -f' semantics changed in rpm5, and no longer resolves symlinks
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# vim:ts=4 sw=4 noet ft=spec
2#
3# PLD Linux rpm macros.
4# <http://www.pld-linux.org/>
5
6# can be used by builder script to check for version
7%rpm_build_macros $Revision$
8
9%epoch 0
10%x8664 x86_64 amd64 ia32e
11%arm armv3l armv4b armv4l armv5teb armv5tel
12
13# kernel compiler
14%kgcc %{__cc}
15%kgcc_package gcc
16
17# compiler version
18%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
19%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
20
21%__rm /bin/rm --interactive=never
22
23# Build system path macros.
24%__autoconf autoconf %{?debug:-Wall}
25%__automake automake -a -c -f --foreign
26%__autopoint autopoint --force
27
28# add parallel build flags: -jN
29#
30# if you want to disable parallel build do:
31# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
32#
33%__make /usr/bin/make %{?_smp_mflags}
34%__scons /usr/bin/scons %{?_smp_mflags}
35%__waf /usr/bin/waf %{?_smp_mflags}
36%__cmake /usr/bin/cmake
37
38%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
39 [ "$_NCPUS" -gt 2 ] && echo "-j$(($_NCPUS / 2))")
40
41%__gettextize { \
42 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
43 gettextize --copy --force --no-changelog; \
44 else \
45 gettextize --copy --force --no-changelog --intl; \
46 fi; \
47 if [ ! -f po/Makevars ]; then \
48 cp -f po/Makevars{.template,}; \
49 fi; \
50}
51
52%__glib_gettextize glib-gettextize --copy --force
53%__gnome_doc_common gnome-doc-common --copy
54%__gnome_doc_prepare gnome-doc-prepare --copy --force
55%__gtkdocize gtkdocize --copy
56%__intltoolize intltoolize --copy --force
57%__libtoolize libtoolize --copy --force --install
58
59# topdir is where builder script lives,
60# fallback to old style if SPECS/SOURCES dirs were found.
61%_topdir %{expand:%%global _topdir %(
62 if [ -d SPECS -a -d SOURCES ]; then
63 # old style rpmdir: in topdir
64 pwd
65 elif [ -d ../SPECS -a -d ../SOURCES ]; then
66 # old style rpmdir: in subdir
67 cd ..; pwd
68 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
69 # if old style rpm dir exist, go with it
70 echo $HOME/rpm; \
71 elif [ -x ../builder -a ! -d ../builder ]; then
72 # relative new style rpmdir: in package dir
73 cd ..; pwd
74 elif [ -x builder -a ! -d builder ]; then
75 # relative new style rpmdir: in packages
76 pwd
77 elif [ -x packages/builder -a ! -d packages/builder ]; then
78 # relative new style rpmdir: packages dir in current dir
79 cd packages; pwd
80 else
81 # fallback to new style rpmdir
82 echo $HOME/rpm/packages
83 fi; \
84)}%_topdir
85
86# if %{_topdir}/SPECS exists, it's old style structure
87%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
88%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
89
90# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
91# if they don't exist assume we are having custom topdir (which is not named as
92# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
93# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
94%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
95%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
96%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
97
98# The number of cvs changelog entries kept when building package.
99%_buildchangelogtruncate 20
100
101%dependencytracking %{nil}
102
103# Relations between package names that cause dependency loops
104# with legacy packages that cannot be fixed. Relations are
105# specified as
106# p>q
107# where package p has a Requires: on something that package q Provides:
108#
109# XXX Note: that there cannot be any whitespace within the string "p>q",
110# and that both p and q are package names (i.e. no version/release).
111%_dependency_whiteout %{nil}
112
113#-----------------------------------------------------------------
114#
115# (re)definition of %{rpm*flags} with %filterout_* support
116# BuildRequires: awk
117# BuildRequires: rpmbuild(macros) >= 1.315
118#
119# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
120# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
121# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
122# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
123# %rpmldflags = %optldflags - %filterout_ld
124#
125# Regular expressions are supported, but to avoid some character be treated
126# as regular expression it must be escaped twice.
127
128%filter_out \
129 for (i = 1; i in I; i++) { A=0; \
130 for (f in F) { \
131 if (I[i] ~ "^" F[f] "$") A=1; \
132 }; \
133 if (!A) printf(I[i] FS); \
134 }
135
136%rpmcflags %(awk 'BEGIN {
137 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
138 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
139 %{filter_out}
140}')
141
142%rpmcxxflags %(awk 'BEGIN {
143 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
144 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
145 %{filter_out}
146}')
147
148%rpmcppflags %(awk 'BEGIN {
149 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
150 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
151 %{filter_out}
152}')
153
154%rpmldflags %(awk 'BEGIN {
155 split("%{?optldflags}",I);
156 split("%{?filterout_ld}",F)
157 %{filter_out}
158}')
159
160# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
161# but, don't use it, better use gcc as linker
162%ld_rpmldflags %(awk 'BEGIN {
163 split("%{rpmldflags}",F);
164 for (f in F) {
165 s = F[f];
166 if (s ~ /^-Wl,/) {
167 s = substr(s,5);
168 gsub(/,/," ",s);
169 };
170 printf(s FS);
171 };
172}')
173
174#-----------------------------------------------------------------
175#
176# Generate a command which cleans environment, leaving only the
177# most important variables.
178# If any spec requires any additional environment it should
179# redefine %_preserve_env in following manner:
180#
181# # ADDITIONAL_VAR is required because [a good reason here]
182# %define _preserve_env ADDITIONAL_VAR
183
184%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
185
186# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
187%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
188 split("%{?_preserve_env}", P);
189 for (i in P) {
190 p = P[i];
191 if (!ENVIRON[p] || d[p]) {
192 continue;
193 }
194 d[p] = 1;
195 split(ENVIRON[p], V, "");
196 val = p "=";
197 for (j = 1; j in V; j++) {
198 v = V[j];
199 if (v == q)
200 v = qq;
201 else if (v == "\\"")
202 v = q2q;
203 else if (v == "\\\\")
204 v = "\\\\\\\\";
205 else
206 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
207 val = val "" v;
208 }
209 printf(val " ");
210 }
211}')
212
213#-----------------------------------------------------------------
214%configure2_13 { \
215 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
216 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
217 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
218 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
219 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
220 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
221 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
222 %{?__cc:CC="%{__cc}" ; export CC ; } \
223 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
224 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
225 --host=%{_target_platform} \
226 --prefix=%{_prefix} \
227 --exec-prefix=%{_exec_prefix} \
228 --bindir=%{_bindir} \
229 --sbindir=%{_sbindir} \
230 --sysconfdir=%{_sysconfdir} \
231 --datadir=%{_datadir} \
232 --includedir=%{_includedir} \
233 --libdir=%{_libdir} \
234 --libexecdir=%{_libexecdir} \
235 --localstatedir=%{_localstatedir} \
236 --sharedstatedir=%{_sharedstatedir} \
237 --mandir=%{_mandir} \
238 --infodir=%{_infodir} \
239 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
240 %{dependencytracking} \
241}
242
243%cmake \
244%{?__cc:CC="%{__cc}"} \\\
245%{?__cxx:CXX="%{__cxx}"} \\\
246CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
247%{__cmake} \\\
248 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
249 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
250 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
251 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
252 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
253 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
254 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
255 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
256 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG}" \\\
257 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
258 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
259 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
260 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
261 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
262%if "%{_lib}" == "lib64" \
263 -DLIB_SUFFIX=64 \\\
264%endif \
265 -DBUILD_SHARED_LIBS:BOOL=ON \\\
266%{nil}
267
268%scons { \
269%{__scons} \
270 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
271 CFLAGS="${CFLAGS:-%rpmcflags}" \
272 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
273 FFLAGS="${FFLAGS:-%rpmcflags}" \
274 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
275 %{?__cc:CC="%{__cc}"} \
276 %{?__cxx:CXX="%{__cxx}"} \
277 libsuffix=%{_lib} \
278 prefix=%{_prefix} \
279}
280
281# waf. see waf.spec
282%waf { \
283CC="%{__cc}" \
284CXX="%{__cxx}" \
285CPP="%{__cpp}" \
286CFLAGS="%{rpmcflags}" \
287CXXFLAGS="%{rpmcxxflags}" \
288%{__waf} \
289}
290
291#----------------------------------------------------------------
292#%configure_cache 0
293%configure_cache_file %{buildroot}.configure.cache
294
295%configure {./configure \
296 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
297 CFLAGS="${CFLAGS:-%rpmcflags}" \
298 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
299 FFLAGS="${FFLAGS:-%rpmcflags}" \
300 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
301 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
302 %{?__cc:CC="%{__cc}"} \
303 %{?__cxx:CXX="%{__cxx}"} \
304 --host=%{_target_platform} \
305 --build=%{_target_platform} \
306 --prefix=%{_prefix} \
307 --exec-prefix=%{_exec_prefix} \
308 --bindir=%{_bindir} \
309 --sbindir=%{_sbindir} \
310 --sysconfdir=%{_sysconfdir} \
311 --datadir=%{_datadir} \
312 --includedir=%{_includedir} \
313 --libdir=%{_libdir} \
314 --libexecdir=%{_libexecdir} \
315 --localstatedir=%{_localstatedir} \
316 --sharedstatedir=%{_sharedstatedir} \
317 --mandir=%{_mandir} \
318 --infodir=%{_infodir} \
319 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
320 %{dependencytracking} \
321 %{?configure_cache:--cache-file=%{configure_cache_file}} \
322}
323
324# Simple macros to simplify adding bconded options to configure scripts.
325# Each macro requires bcond name and accepts optional option name, if option
326# isn't specified bcond name is used as option name. Options returning
327# --with and --enable also allow third argument which will be added as value
328# ( --with-option=value or --enable-option=value ) in case or positive
329# condition, but won't be added otherwise ( nothing or just --disable-option ).
330
331# Requirements:
332# BuildRequires: rpmbuild(macros) >= 1.527
333
334# Usage example:
335# %{__enable bcond} - returns --enable-bcond iff build condition is set
336# %{__disable bcond option} - returns --enable-option iff bcond is not set
337# %{__enable_disable bcond option value} - returns --enable-option=value if
338# bcond is set, returns --disable-option otherwise
339
340# expand bconds to --enable-something and --disable-something
341%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
342%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
343%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
344
345# same as above, but condition inverted
346%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
347%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
348%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
349
350# expand bconds to --with-something and --without-something
351%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
352%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
353%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
354
355# same as above, but condition inverted
356%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
357%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
358%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
359
360#-----------------------------------------------------------------
361
362# overload to insert debuginfo package
363%prep \
364%if 0%{?_enable_debug_packages}\
365%{debug_package}\
366%endif\
367%%prep\
368%{nil}
369
370# Location of autoconf macros
371%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
372
373# Location of omf files
374%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
375
376# Location of pkgconfig files
377%_pkgconfigdir /usr/%{_lib}/pkgconfig
378# noarch pkgconfig files
379%_npkgconfigdir /usr/share/pkgconfig
380
381# Location of desktop files
382%_desktopdir /usr/share/applications
383%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
384
385# Location of pixmaps for applnk/desktop files
386%_pixmapsdir /usr/share/pixmaps
387
388# Location of themable icons for applnk/desktop files
389%_iconsdir /usr/share/icons
390
391# Location of fonts directories
392%_fontsdir /usr/share/fonts
393
394# Location of Gtk and associated libraries documentation
395%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
396
397# Location of KDE documentation
398%_kdedocdir %{_defaultdocdir}/kde/HTML
399
400# unsermake script
401%__unsermake /usr/share/unsermake/unsermake
402
403# Current date
404%date %(LC_ALL=C date +"%a %b %d %Y")
405
406# Example files, programs, scripts...
407%_examplesdir /usr/src/examples
408
409# Alternative kernel type/version
410%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
411
412# The directory holding Linux kernel sources
413%_kernelsrcdir /usr/src/linux%{_alt_kernel}
414
415# SysV-style initscripts dir
416%_initddir /etc/rc.d/init.d
417
418# If non-empty "debug" macro defined, add "dbg" suffix to release number
419%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
420
421# Bootstrap release macros.
422# Usage:
423# %bcond_with bootstrap
424# Release: %{bootstrap_release 1}
425#
426# Package will have release 1 if built normally,
427# and release 0.zzz.bootstrap if built with bootstrap
428%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
429
430# -n drm to generate kernel%{_alt_kernel}-drm dependency
431%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
432%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
433%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
434
435# -s post to generate Requires(post) dependency
436%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
437%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
438%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
439
440# Requires name = version-release
441%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
442# Requires: name = version
443%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
444# Requires: name = version (version based on querying package %2)
445%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
446
447# Requires: name >= version
448%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
449# Requires: name >= version (version based on querying package %2)
450%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
451
452# \helper for renaming packages
453# %rename old-package
454%rename() \
455Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
456Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
457
458%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
459
460# kernel version-release handling
461%__kernel_ver %{expand:%%global __kernel_ver %( \\
462 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
463 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
464 echo ${Z:-ERROR}; \\
465)}%__kernel_ver
466
467%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -qf include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
468%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -qf include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
469%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
470%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
471
472# `uname -r` to be used in @release field
473%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
474
475# sgml macros
476%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
477%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
478%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
479%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
480%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
481%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
482%docbook_sgmlcat_fix() { for l in \
483'' \
484' -- default decl --' \
485'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
486' -- hacks for opensp --' \
487'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
488'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
489'' \
490; do echo $l; done >> %1 \
491}
492
493# vim - "
494
495# minimum file size needed for compressed documents.
496# just smaller files than this get larger when compressed.
497# some stats:
498# - 0 byte file compressed was 25 bytes .gz
499# - 39 byte file was compressed as 57
500# - with test/test.spec@man 158 byte file was compressed also 158
501%_min_compress_bytes 159
502
503#-----------------------------------------------------------------
504# find and gzip all files in %{_mandir} and %{infodir}
505#
506# Requires: xargs, find
507#
508#%no_install_post_compress_docs 1
509%__spec_install_post_compress_docs { \
510%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
511 %{!?debug:set +x;} \
512 for i in /usr/share/man /usr/X11R6/man; do \
513 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
514 echo "Compress man pages: $i"; \
515 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
516 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
517 find $RPM_BUILD_ROOT$i -type l | while read a; do \
518 m=$(readlink "$a"); \
519 if [[ "$m" = */* ]]; then \
520 # handle links to different man section \
521 l=$(readlink -f "$a"); \
522 # full/relative paths that resolve symlink \
523 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
524 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
525 # full paths that do not resolve symlink \
526 l=${l#/usr/share/man/}; \
527 l=${l#/usr/X11R6/man/}; \
528 else \
529 l=${a#$RPM_BUILD_ROOT$i/}; \
530 l=${l%/*}; \
531 l="$l/$m"; \
532 fi; \
533 rm -f $a; \
534 echo ".so $l" > $a; \
535 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
536 done; \
537 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
538 fi; \
539 done; \
540 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
541 echo "Compress info pages: %{_infodir}"; \
542 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
543 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
544 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
545 fi; \
546}; __spec_install_post_compress_docs } }
547
548#-----------------------------------------------------------------
549# Strip executable binaries and shared object files
550#
551# Requires: find, awk, strip, cut, xargs
552#
553# Special macros which affect this process:
554#%no_install_post_strip 1 # disable stripping at all
555#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
556#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
557#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
558#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
559#
560%__spec_install_post_strip {%{!?debug: \
561%{!?no_install_post_strip:__spec_install_post_strip() { \
562%{!?debug:set +x;} \
563if [ -d "$RPM_BUILD_ROOT" ]; then \
564 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
565 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
566 if [ "$modulelist" ]; then \
567 modulecount=$(echo "$modulelist" | wc -l); \
568 printf "Stripping %d kernel modules..." $modulecount; \
569 echo "$modulelist" | xargs -l512 chmod u+w; \
570 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
571 echo "DONE"; \
572 fi; \
573 fi; \
574 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
575 if [ -n "$filelist" ]; then \
576 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
577 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
578 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
579 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
580 if [ -n "$elfexelist" ]; then \
581 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
582 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
583 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
584 echo "DONE"; \
585 fi; \
586 if [ -n "$elfsharedlist" ]; then \
587 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
588 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
589 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
590 echo "DONE"; \
591 fi; \
592 if [ -n "$archiveslist" ]; then \
593 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
594 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
595 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
596 echo "DONE"; \
597 fi; \
598 fi; \
599 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
600 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
601 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
602 if [ -n "$filelist_all" ]; then \
603 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
604 chmod u+w $filelist_all; \
605 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
606 echo "DONE"; \
607 fi; \
608 if [ -n "$filelist_unneeded" ]; then \
609 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
610 chmod u+w $filelist_unneeded; \
611 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
612 echo "DONE"; \
613 fi; \
614 if [ -n "$filelist_debug" ]; then \
615 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
616 chmod u+w $filelist_debug; \
617 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
618 echo "DONE"; \
619 fi; \
620fi; }; __spec_install_post_strip } } }
621
622#-----------------------------------------------------------------
623# remove all RPATH from executable binaries and shared object files
624#
625# Requires: find, awk, cut, xargs, chrpath, uname
626#
627# Special macros which affect this process
628#%no_install_post_chrpath 1 # disable chrpath at all
629#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
630#
631%__spec_install_post_chrpath {%{!?debug: \
632%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
633%{!?debug:set +x;} \
634if [ -d "$RPM_BUILD_ROOT" ]; then \
635 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
636 if [ -n "$files" ]; then \
637 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
638 fi; \
639 if [ -n "$objs" ]; then \
640 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
641 echo "$objs" | \
642 while read file; do \
643 rpath= ; \
644 chmod u+w "$file"; \
645 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
646 case $dir in \
647 '$ORIGIN' ) \
648 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
649 else rpath="$rpath:$dir" ; fi ; \
650 continue ; \
651 ;; \
652 esac ; \
653 newdir=$(readlink -m "$dir"); \
654 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
655 case $dir in \
656 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
657 echo "remove-rpath: $dir in $file"; \
658 ;; \
659 * ) \
660 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
661 else rpath="$rpath:$dir" ; fi ; \
662 ;; \
663 esac ; \
664 done ; \
665 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
666 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
667 done; \
668 fi; \
669fi; }; __spec_install_post_chrpath } } }
670
671# vim: "
672
673#-----------------------------------------------------------------
674# Find all shared object files with unresolved symbols. Warn
675# and terminate if any found (termination can be turned off by define).
676#%no_install_post_check_so 1
677#%skip_post_check_so libwithunresolvedok.so.*
678#
679# NOTE: define skip_post_check_so only if such library really requires
680# unresolved symbols and always leave a comment why it is required:
681# # executable provides symbols foo, bar for those libraries:
682# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
683#
684%__spec_install_post_check_so { \
685__spec_install_post_check_so() { \
686%{!?debug:set +x;} \
687 fail=0; \
688 printf "Searching for shared objects with unresolved symbols..."; \
689 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
690 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
691 done ; \
692 echo " DONE"; \
693 %{!?no_install_post_check_so:return $fail;} \
694}; __spec_install_post_check_so }}
695
696#-----------------------------------------------------------------
697# Verify that for each directory under /var/run package contains
698# tmpfiles.d configuration. Warn and terminate build if config is
699# missing.
700#
701#%no_install_post_check_tmpfiles 1
702#
703%__spec_install_post_check_tmpfiles { \
704__spec_install_post_check_tmpfiles() { \
705%{!?debug:set +x;} \
706 fail=0; \
707 echo "Checking /var/run <-> tmpfiles.d completeness..."; \
708 for d in $RPM_BUILD_ROOT/var/run/*; do \
709 [ -d "$d" ] || continue; \
710 d=${d##$RPM_BUILD_ROOT}; \
711 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
712 echo "No tmpfiles configuration for '$d'";\
713 fail=1 ; \
714 fi \
715 done ; \
716 echo " DONE"; \
717 %{!?no_install_post_check_tmpfiles:return $fail;} \
718}; __spec_install_post_check_tmpfiles }}
719
720#-----------------------------------------------------------------
721# Find and gzip all kernel modules
722#
723# Requires: find
724#
725#%no_install_post_compress_modules 1
726%__spec_install_post_compress_modules { \
727%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
728%{!?debug:set +x;} \
729 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
730 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
731 if [ "$q" ]; then \
732 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
733 echo "$q" | xargs -r %{__gzip} -9nf; \
734 echo "DONE"; \
735 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
736 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
737 fi; \
738 fi; \
739}; __spec_install_post_compress_modules } }
740
741# Remove common Perl files we don't package
742%__spec_install_post_perl_clean {\
743%{!?no_install_post_perl_clean: \
744%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
745} }
746
747#-----------------------------------------------------------------
748# Update GConf2 schemas
749#
750# Requires: GConf2
751#
752%gconf_schema_install() \
753 umask 022; \
754 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
755 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
756%{nil}
757
758%gconf_schema_uninstall() \
759if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
760 umask 022; \
761 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
762 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
763fi; \
764%{nil}
765
766#-----------------------------------------------------------------
767# Update desktop MIME database
768# requires: desktop-file-utils
769%update_desktop_database() {{ \
770 umask 022; \
771 /usr/bin/update-desktop-database -q; \
772};} \
773%{nil}
774
775%update_desktop_database_post %update_desktop_database
776
777%update_desktop_database_postun() {{ \
778if [ "$1" = "0" ]; then \
779 %update_desktop_database \
780fi; \
781};} \
782%{nil}
783
784#-----------------------------------------------------------------
785# Update shared MIME info database
786# requires: shared-mime-info
787#
788%update_mime_database() {{ \
789 umask 022; \
790 /usr/bin/update-mime-database %{_datadir}/mime; \
791};} \
792%{nil}
793
794#-----------------------------------------------------------------
795# Update icon cache
796# BuildRequires: rpmbuild(macros) >= 1.596
797# Requires: hicolor-icon-theme
798#
799%update_icon_cache() {{ \
800 %{!?1:%{error:%{0}: Required theme name missing}} \
801 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
802 umask 022; \
803 touch --no-create %{_iconsdir}/%1; \
804 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
805 fi; \
806};} \
807%{nil}
808
809#-----------------------------------------------------------------
810# Update scrollkeeper database
811# requires: scrollkeeper
812#
813%scrollkeeper_update_post() \
814 /usr/bin/scrollkeeper-update -q; \
815%{nil}
816
817%scrollkeeper_update_postun() \
818if [ "$1" = "0" ]; then \
819 /usr/bin/scrollkeeper-update -q; \
820fi; \
821%{nil}
822
823#-----------------------------------------------------------------
824# Compile GSettings schemas
825# requires: glib2 >= 1:2.26.0
826#
827%glib_compile_schemas() {{ \
828 umask 022; \
829 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
830};} \
831%{nil}
832
833#-----------------------------------------------------------------
834# post %install sequence:
835# - autodeps exceptions
836# - compress all man and info pages,
837# - strip all ELF executables and ELF shared objects if not %debug.
838# - compress kernel modules if any
839
840###################################################################
841# Requires/Provides automation
842# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
843#
844%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
845%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
846%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
847%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
848%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
849
850#%_noautocompressdoc %{nil}
851#
852%_missing_doc_files_terminate_build 1%{nil}
853%_unpackaged_files_terminate_build %{nil}
854# (X)emacs support
855%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
856%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
857%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
858
859%__php_provides %{nil}
860%__php_requires %{nil}
861%__perl_provides %{nil}
862%__perl_requires %{nil}
863%__mono_provides %{nil}
864%__mono_requires %{nil}
865
866# Perl specific macro definitions.
867%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
868%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
869%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
870%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
871%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
872%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
873
874# Ruby
875%__ruby /usr/bin/ruby
876%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
877%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
878%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
879%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
880%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
881%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
882%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
883%ruby_rdocdir /usr/share/rdoc
884%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
885%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
886%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
887
888%php_pear_dir /usr/share/pear
889%php_data_dir /usr/share/php
890%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
891%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
892%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
893
894# extract php/zend api versions
895%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
896%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
897%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
898%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
899%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
900%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
901%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
902%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
903# "_ts" if ZTS enabled, empty otherwise
904%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
905
906# name of php package
907%php_name php%{?php_suffix}
908# use rpmbuild -D 'php_suffix 54' to build php extension for php 5.4
909%php_suffix %{nil}
910
911# helper macro
912%__php_api_requires(v:) Requires: %{php_name}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
913
914# macros for public use
915# for php extensions (php-pecl)
916%requires_php_extension %{__php_api_requires modules_api php_api_version} \
917%{__php_api_requires zend_module_api} \
918%{__php_api_requires debug php_debug} \
919%{__php_api_requires thread-safety _zend_zts}
920
921# for zend extensions
922%requires_zend_extension %{__php_api_requires zend_module_api} \
923%{__php_api_requires zend_extension_api} \
924%{__php_api_requires debug php_debug} \
925%{__php_api_requires thread-safety _zend_zts}
926
927# for php pdo modules (php-pecl-PDO_*)
928%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
929
930# for using PHP post scripts. for PHP >= 5.0
931%php_webserver_restart \
932[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
933[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
934if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
935 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
936 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
937 %service -q php-fcgi restart \
938 fi \
939fi \
940if [ -x /etc/rc.d/init.d/php-fpm ]; then \
941 %service -q php-fpm restart \
942fi \
943%{nil}
944
945# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
946%php4_webserver_restart \
947[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
948[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
949if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
950 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
951 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
952 %service -q php-fcgi restart \
953 fi \
954fi \
955%{nil}
956
957# X.org helper macros
958%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
959%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
960
961%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
962%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
963%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
964%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
965%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
966# vim: '
967
968%requires_xorg_xserver_extension \
969%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
970%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
971%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
972%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
973%{nil}
974
975%requires_xorg_xserver_xinput \
976%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
977%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
978%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
979%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
980%{nil}
981
982%requires_xorg_xserver_font \
983%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
984%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
985%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
986%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
987%{nil}
988
989%requires_xorg_xserver_videodrv \
990%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
991%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
992%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
993%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
994%{nil}
995
996# TCL specific macro definitions.
997# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
998%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
999%tcl_sitearch %{_libdir}/tcl%{tcl_version}
1000%tcl_sitelib %{_datadir}/tcl%{tcl_version}
1001
1002# Python specific macro definitions.
1003# python main version
1004%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
1005
1006# directories
1007%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
1008%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
1009%py_scriptdir %{py_prefix}/share/python%{py_ver}
1010%py_incdir /usr/include/python%{py_ver}
1011%py_sitedir %{py_libdir}/site-packages
1012%py_sitescriptdir %{py_scriptdir}/site-packages
1013%py_dyndir %{py_libdir}/lib-dynload
1014
1015# pure python modules compilation
1016%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1017
1018%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1019
1020# Software written in Python language require Python with main version
1021%pyrequires_eq() Requires: %1
1022
1023# Python 3.x
1024# python main version
1025%__python3 python3
1026%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
1027
1028# directories
1029%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
1030%py3_libdir %{expand:%%global py3_libdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platstdlib'))" 2>/dev/null || echo ERROR)}%py3_libdir
1031%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
1032%py3_sitedir %{expand:%%global py3_sitedir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platlib'))" 2>/dev/null || echo ERROR)}%py3_sitedir
1033%py3_sitescriptdir %{expand:%%global py3_sitescriptdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('purelib'))" 2>/dev/null || echo ERROR)}%py3_sitescriptdir
1034%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
1035%py3_dyndir %{py3_libdir}/lib-dynload
1036
1037# pure python modules compilation
1038%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1039
1040%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1041
1042# node.js libdir
1043# Requirements:
1044# BuildRequires: rpmbuild(macros) >= 1.634
1045%nodejs_libdir /usr/lib/node_modules
1046
1047# Hardlink binary identical .pyc and .pyo files
1048%__spec_install_post_py_hardlink {\
1049%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
1050%{!?debug:set +x;} \
1051local a b c=0 t=0; \
1052if [ -d "$RPM_BUILD_ROOT" ]; then \
1053 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
1054 while read a; do \
1055 b="${a%.pyc}.pyo"; \
1056 if cmp -s "$a" "$b"; then \
1057 ln -f "$a" "$b"; \
1058 c=$((c + 1)); \
1059 fi; \
1060 t=$((t + 1)); \
1061 done < __rpm_pyc; \
1062 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1063 rm -f __rpm_pyc; \
1064fi; \
1065}; __spec_install_post_py_hardlink } }
1066
1067# remove python sources, so that check-files won't complain
1068%py_postclean() \
1069for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1070 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
1071done \
1072%{nil}
1073
1074# depmod macro
1075%depmod() { \
1076umask 022; \
1077if [ -e /boot/System.map-%1 ]; then \
1078 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1079else \
1080 if [ -e /boot/System.map ]; then \
1081 /sbin/depmod -a -F /boot/System.map %1; \
1082 else \
1083 /sbin/depmod -a %1; \
1084 fi \
1085fi; \
1086}
1087
1088# XMMS specific macros
1089%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1090%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1091%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1092%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1093%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1094%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1095%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1096%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1097%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1098%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1099
1100%_host_base_arch %{expand:%%global _host_base_arch %(echo %{_host_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_host_base_arch
1101%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1102
1103# user/group checking macros
1104#
1105# Usage:
1106# %userremove myuser
1107#
1108%userremove /usr/lib/rpm/user_group.sh user del
1109%groupremove /usr/lib/rpm/user_group.sh group del
1110#
1111# Usage:
1112# if %usertestrm myuser; then
1113# /usr/sbin/userdel -r myuser
1114# Note:
1115# use these macros only if you need to call userdel/groupdel with
1116# a non-standard option or take an extra action; otherwise use the
1117# %userremove/%groupremove macros
1118#
1119%usertestrm /usr/lib/rpm/user_group.sh user testrm
1120%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1121# user group membership management macros
1122#
1123# Usage:
1124# %addusertogroup [-q] myuser agroup
1125#
1126# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1127#
1128# Requirements:
1129# BuildRequires: rpmbuild(macros) >= 1.515
1130%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1131%{nil}
1132
1133# banner support (useful in {pre,post}{,un} and triggers)
1134#
1135# Usage:
1136# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1137# the banner text, the banner text
1138# the banner text, and following line
1139#EOF
1140# You can use any form of here-document, <<'EOF' <<-EOT will do.
1141# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1142#
1143# -a - append to the banner
1144# -e - send to stderr instead of stdout
1145# -n - no show banner (overrides -t)
1146# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1147# -o - show only once, i.e when package is installed for the first time
1148#
1149# Tests:
1150# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1151# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1152# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1153# rpm -E 'date | %banner -e banner' > m; sh -x m
1154# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1155#
1156%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1157RPM_SCRIPTVERBOSITY=5 \
1158[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1159if [ -x /usr/bin/banner.sh ]; then \
1160 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1161else \
1162 CMD="cat%{-e: >&2}" \
1163fi \
1164eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1165%{nil}
1166
1167# useradd/groupadd macros
1168# Author: Elan Ruusamäe <glen@pld-linux.org>
1169#
1170# Usage:
1171# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1172# [-g initial_group] [-G group[,...]] login
1173#
1174# -u uid. REQUIRED
1175# -g gid/group. REQUIRED
1176# -s defaults to /bin/false
1177# -d defaults to /usr/share/empty
1178# -c No default
1179# -r is accepted but ignored (it's always set)
1180# -k skeleton dir. defaults to /usr/share/empty
1181# rpm specific flags
1182# -P package name. defaults to %{name}
1183#
1184%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1185%{!-u:%{error:useradd: Required argument -u missing}} \
1186%{!-g:%{error:useradd: Required argument -g missing}} \
1187%{!?1:%{error:useradd: Required parameter login missing}} \
1188if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1189 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1190 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1191 exit 1 \
1192 fi \
1193else \
1194 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1195 /usr/sbin/useradd \\\
1196 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1197 -u %{-u*} \\\
1198 -r \\\
1199 -d %{-d*}%{!-d:/usr/share/empty} \\\
1200 -s %{-s*}%{!-s:/bin/false} \\\
1201 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1202 -g %{-g*} \\\
1203 %{-M} \\\
1204 %{-G:-G %{-G*}} \\\
1205 %{expand:%{%{#}}} 1>&2 || exit $? \
1206 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1207fi;
1208# vim: "
1209
1210# Usage:
1211# %groupadd [-P package] [-g gid] group
1212#
1213# -g gid. REQUIRED
1214#
1215# Sample:
1216# %groupadd -P %{name}-base -g %{gid} %{name}
1217
1218%groupadd(g:P:rfo) \
1219%{!-g:%{error:groupadd: Required argument -g missing}} \
1220%{!?1:%{error:groupadd: Required parameter group missing}} \
1221if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1222 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1223 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1224 exit 1 \
1225 fi \
1226else \
1227 echo "Adding group %{1} GID=%{-g*}." \
1228 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1229 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1230fi;
1231
1232# webapp macros
1233# Author: Elan Ruusamäe <glen@pld-linux.org>
1234#
1235# The config is installed/removed inside trigger, this means that you can any
1236# time install apache1/apache/lighttpd package and the configuration file is
1237# updated. if you don't need the config for various reason for specific
1238# webserver, just remove the symlink from config directory using webapp
1239# program. the trigger will not recreate the symlink on upgrades. In other
1240# words the config is linked to webserver config directory on first install of
1241# PACKAGE or WEBSERVER.
1242#
1243# Add package's webserver config to webserver webapps dir.
1244# Usage:
1245# %webapp_register [-f] WEBSERVER WEBAPP
1246#
1247%webapp_register(f) \
1248%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1249if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1250 /usr/sbin/webapp register %1 %2\
1251fi\
1252# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1253if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1254 %{expand:%service -q %%1 reload}\
1255fi\
1256%{nil}
1257
1258# Remove package's config from webserver webapps dir.
1259# Usage:
1260# %webapp_register [-f] WEBSERVER WEBAPP
1261%webapp_unregister(f) \
1262%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1263# remove link if either of the packages are gone \
1264if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1265 /usr/sbin/webapp unregister %1 %2\
1266 %{expand:%service -q %%1 reload}\
1267fi \
1268%{nil}
1269
1270# service macro.
1271# Author: Elan Ruusamäe <glen@pld-linux.org>
1272#
1273# calls usual service restart on package %post, but skips the restart if
1274# administrator has disabled automatic service restarts in either global
1275# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1276#
1277# Usage:
1278# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1279#
1280# -q be silent when service isn't started (for scriplets restaring other package's services)
1281# -n NOOP mode, do not actually restart service
1282#
1283# Requirements:
1284# BuildRequires: rpmbuild(macros) >= 1.268
1285# Requires: rc-scripts
1286# -n option:
1287# BuildRequires: rpmbuild(macros) >= 1.450
1288%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1289
1290# Java macros. based on jpackage macros.java
1291#
1292# Root directory where all Java VMs/SDK/JREs are installed.
1293%_jvmdir %{_libdir}/jvm
1294
1295# Root directory where all Java VMs/SDK/JREs expose their jars
1296%_jvmjardir %{_libdir}/jvm-exports
1297
1298# Root directory for all Java VM/SDK/JRE's private things.
1299%_jvmprivdir %{_libdir}/jvm-private
1300
1301# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1302%_jvmlibdir %{_libdir}/jvm
1303
1304# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1305%_jvmdatadir %{_datadir}/jvm
1306
1307# Root directory for all configurations parts of Java VM/SDK/JRE's
1308%_jvmsysconfdir %{_sysconfdir}/jvm
1309
1310# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1311%_jvmcommonlibdir %{_libdir}/jvm-common
1312
1313# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1314%_jvmcommondatadir %{_datadir}/jvm-common
1315
1316# Root directory for all common configurations parts of Java VM/SDK/JRE's
1317%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1318
1319# Directory where arch-specific (JNI) version-independent jars are installed.
1320%_jnidir %{_libdir}/java
1321
1322
1323# JDK selection. Set this to name of the JDK implementation to use
1324# insead of the system default
1325#%use_jdk icedtea6
1326
1327# expands to the value with right jdk for BuildRequires header
1328# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1329# The requirement will not replace current 'default' JDK
1330%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1331
1332%buildrequires_jdk BuildRequires: %required_jdk
1333
1334%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1335
1336%_javasrcdir %{_usrsrc}/java
1337
1338%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1339%jar %{java_home}/bin/jar
1340%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1341%javac %{java_home}/bin/javac
1342%javadoc %{java_home}/bin/javadoc
1343
1344%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1345
1346%jpackage_script() \
1347install -d $RPM_BUILD_ROOT%{_bindir}\
1348cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1349#!/bin/sh\
1350#\
1351# %{name} script\
1352# JPackage Project <http://www.jpackage.org/>\
1353\
1354# Source functions library\
1355. %{_javadir}-utils/java-functions\
1356\
1357# Source system prefs\
1358if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1359 . %{_sysconfdir}/java/%{name}.conf\
1360fi\
1361\
1362# Source user prefs\
1363if [ -f $HOME/.%{name}rc ]; then\
1364 . $HOME/.%{name}rc\
1365fi\
1366\
1367# Configuration\
1368MAIN_CLASS=%1\
1369BASE_FLAGS=%2\
1370BASE_OPTIONS=%3\
1371BASE_JARS="%(echo %4 | tr ':' ' ')"\
1372\
1373# Set parameters\
1374set_jvm\
1375set_classpath $BASE_JARS\
1376set_flags $BASE_FLAGS\
1377set_options $BASE_OPTIONS\
1378\
1379# Let's start\
1380run "$@"\
1381EOF
1382
1383# jpackage 1.7
1384# Directory for maven depmaps
1385#
1386%_mavendepmapdir /etc/maven
1387%_mavendepmapfragdir /etc/maven/fragments
1388
1389#
1390# add_to_depmap adds an entry to the depmap. The arguments are:
1391#
1392# %1 the original groupid
1393# %2 the original artifact id
1394# %3 the version
1395# %4 the new groupid
1396# %5 the new artifactid
1397#
1398
1399%add_to_maven_depmap() \
1400install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1401cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1402<dependency>\
1403 <maven>\
1404 <groupId>%1</groupId>\
1405 <artifactId>%2</artifactId>\
1406 <version>%3</version>\
1407 </maven>\
1408 <jpp>\
1409 <groupId>%4</groupId>\
1410 <artifactId>%5</artifactId>\
1411 <version>%3</version>\
1412 </jpp>\
1413</dependency>\
1414\
1415EOF\
1416%{nil}
1417
1418#==============================================================================
1419#
1420# update_maven_depmap updates the main maven depmap
1421#
1422%update_maven_depmap() \
1423echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1424if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1425cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1426fi\
1427echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1428
1429# JAVA macros specific for PLD
1430
1431# Directory for tomcat context configuration files
1432%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1433
1434# Tomcat cache path
1435%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1436
1437# Clear tomcat cache
1438# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1439#
1440# Usage:
1441# %%tomcat_clear_cache appname
1442#
1443# Call this script in %postun scriptlet. It will remove compiled jsps related to
1444# given app.
1445#
1446%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1447
1448# PEAR install macros
1449# Author: Elan Ruusamäe <glen@pld-linux.org>
1450#
1451# Usage:
1452# %%pear_package_setup ...
1453#
1454# -a # - also unpack SOURCE#. for PEAR bootstrapping
1455# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1456# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1457# -D - pass -D to %setup (so the build dir is not removed)
1458# -c - register channel from local channel.xml file
1459# -d - pass -d arg to pearcmd
1460#
1461# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1462# destination hierarchy. you should copy the tree to buildroot after
1463# patching/reorganizing with %%pear_package_install.
1464#
1465# additionally BUILDROOT is stripped from files and files are converted to UNIX
1466# line endings.
1467#
1468# the pear install process output is recorded to install.log, you should put it
1469# to %%doc for later debug or just for information.
1470#
1471# additionally additional-packages.txt is produced if it was detected that the
1472# package has optional dependencies. the file format is suitable of displaying
1473# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1474# automatically added for this file.
1475
1476
1477# records install.log and transforms PEAR names to PLD Linux rpm package names.
1478%__pear_install_log \
1479tee install.log \
1480# make post message of optional packages \
1481grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1482if [ -s optional-packages.txt ]; then \
1483 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1484else \
1485 rm -f optional-packages.txt \
1486fi \
1487%{nil}
1488
1489# Command invoking PEAR CLI
1490# Same as /usr/bin/pear, except we force GMT timezone
1491%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT /usr/share/pear/pearcmd.php
1492
1493%pear_install(a:d:n:zD) \
1494%__pear \\\
1495 -c %{builddir}/pearrc \\\
1496 -d doc_dir=/docs \\\
1497 -d temp_dir=/tmp \\\
1498 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1499 -d bin_dir=%{_bindir} \\\
1500 -d data_dir=%{php_pear_dir}/data \\\
1501 -d test_dir=%{php_pear_dir}/tests \\\
1502 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1503 install \\\
1504 --packagingroot=%{builddir} \\\
1505 --offline \\\
1506 --nodeps \\\
1507 %{-f:--force} \\\
1508 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1509 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1510%{nil}
1511
1512# The main macro.
1513# using this macro will append optional-packages.txt to the nocompressdoc list
1514# as it's displayed to user after package install. and adding additional gzip
1515# dep is just waste ;)
1516%pear_package_setup(a:d:n:zDc:) \
1517%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1518%define builddir %{_builddir}/%{srcdir} \
1519%setup -q -c -T %{-D:-D} -n %{srcdir} \
1520%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1521%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1522%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1523%pear_install \
1524%{-z:cd ..} \
1525%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1526cat %{-z:$_N/}.install.log | %__pear_install_log \
1527%undos -f php,html,js,xml \
1528%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1529%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1530%{nil}
1531
1532# Copies extracted PEAR package structure and PEAR registry to buildroot.
1533# Author: Elan Ruusamäe <glen@pld-linux.org>
1534%pear_package_install() \
1535cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1536# tests should not be packaged \
1537%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1538# cleanup backups \
1539find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1540# help the developer out a little: \
1541if [ -f _noautoreq ]; then \
1542 echo "AutoReqdep detected:" \
1543 echo "_noautoreq $(cat _noautoreq)" \
1544fi \
1545%{nil}
1546
1547# Print optional package info for pear packages
1548# Author: Elan Ruusamäe <glen@pld-linux.org>
1549# Usage:
1550# %post -p <lua>
1551# %%pear_package_print_optionalpackages
1552#
1553# Requirements:
1554# BuildRequires: rpmbuild(macros) >= 1.571
1555%pear_package_print_optionalpackages \
1556f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1557if f then \
1558 for l in f:lines() do print(l); end \
1559end \
1560%{nil}
1561
1562
1563# Register OpenLDAP schema.
1564# Author: Elan Ruusamäe <glen@pld-linux.org>
1565#
1566# Usage:
1567# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1568#
1569# -d specify dependant schemas, separated by comma
1570#
1571%openldap_schema_register(d:) \
1572for schema in %*; do \
1573 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1574 %{__sed} -i -e " \
1575 /^include.*local.schema/{ \
1576 iinclude\\t $schema\
1577 } \
1578 " /etc/openldap/slapd.conf \
1579 fi \
1580done \
1581# enable dependant schemas \
1582if [ "%{-d*}" ]; then \
1583 %{__sed} -i -e ' \
1584 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1585 s/^#// \
1586 }' /etc/openldap/slapd.conf \
1587fi \
1588%{nil}
1589
1590# Unregister OpenLDAP schema.
1591# Author: Elan Ruusamäe <glen@pld-linux.org>
1592#
1593# Usage:
1594# %%openldap_schema_unregister %{schemadir}/horde.schema
1595#
1596%openldap_schema_unregister() \
1597for schema in %*; do \
1598 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1599 %{__sed} -i -e " \
1600 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1601 # for symmetry it would be nice if we disable enabled schemas in post, \
1602 # but we really can not do that, it would break something else. \
1603 " /etc/openldap/slapd.conf \
1604 fi \
1605done \
1606%{nil}
1607
1608%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1609
1610
1611# Build modules for kernels 2.6
1612# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1613#
1614# Usage:
1615# %build_kernel_modules -m <modules> -C <directory>
1616#
1617# remember that proper Makefile is still required
1618# Options:
1619# -m <modules> (required) -- comma-separated list of modules to save,
1620# without .ko extension, may be placed in subdirectory
1621# -C <directory> -- change to <directory> before doing anything
1622# -p <arg>, -P <arg> -- arguments passeed to make scripts
1623# -c -- do not execute make clean
1624# <additional arguments> -- all additional arguments will be passed to
1625# make modules
1626#
1627# Additional patching supported via here document. Try:
1628# %build_kernel_modules -m module <<'EOF'
1629# your patch script here
1630# EOF
1631# Don't use it unless patching depends on config options.
1632
1633# Developer note: don't touch it unless you know how to handle '\'.
1634# - \ in script expands to nothing
1635# - \\\ in script expands to \
1636# - \\\ inside definition expands to nothing
1637# - \\\\\\\ inside definition expands to \
1638# - in last line \ has to touch arguments so arguments passing
1639# in new lines (using \) will be supported
1640
1641%build_kernel_modules(p:P:m:C:c) \
1642%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1643 \
1644%define Opts \\\\\\\
1645%if "%{_target_base_arch}" != "%{_host_base_arch}" \\\
1646 %if "%{_host_base_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1647 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1648 %else \\\
1649 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1650 %endif \\\
1651%else \\\
1652 CC="%{kgcc}" \\\
1653%endif \
1654%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1655 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1656 \
1657%{?-C:cd %{-C*}} \
1658compile() { \
1659 local L="<" PATCH_SH; \
1660 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1661 set -e -x \
1662 \
1663 [ -r "%{_kernelsrcdir}/.config" ] || exit 1 \
1664 rm -rf o \
1665 install -d o/include/linux o/include/generated o/arch/x86/include o/arch/powerpc/lib \
1666 ln -sf %{_kernelsrcdir}/.config o/.config \
1667 ln -sf %{_kernelsrcdir}/Module.symvers o/Module.symvers \
1668 if [ -f %{_kernelsrcdir}/include/generated/autoconf.h ]; then \
1669 ln -sf %{_kernelsrcdir}/include/generated/autoconf.h o/include/generated/autoconf.h \
1670 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1671 else \
1672 ln -sf %{_kernelsrcdir}/include/linux/autoconf.h o/include/linux/autoconf.h \
1673 fi \
1674 if [ -d %{_kernelsrcdir}/arch/x86/include/generated ]; then \
1675 ln -s %{_kernelsrcdir}/arch/x86/include/generated o/arch/x86/include \
1676 fi \
1677 \
1678 set +x \
1679 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1680 set -x \
1681 \
1682 install -d o/include/config \
1683 touch o/include/config/MARKER \
1684 ln -sf %{_kernelsrcdir}/include/config/auto.conf o/include/config/auto.conf \
1685 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1686 \
1687 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1688 RCS_FIND_IGNORE="-name '*.[ks]o' -o" \\\
1689 ${1+"$@"} \\\
1690 M=$PWD %{MakeOpts}} \
1691 \
1692 %{__make} -C %{_kernelsrcdir} modules \\\
1693 ${1+"$@"} \\\
1694 M=$PWD CONSTIFY_PLUGIN="" %{MakeOpts} \
1695%{?-C:cd -} \
1696} \
1697compile_old() { \
1698 local L="<" PATCH_SH; \
1699 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1700 set -e -x \
1701 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1702 \
1703for cfg in ${cfgs:-dist}; do \
1704 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1705 \
1706 rm -rf o \
1707 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1708 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1709 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1710 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1711 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1712 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1713 else \
1714 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1715 fi \
1716 \
1717 set +x \
1718 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1719 set -x \
1720 \
1721 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1722 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1723 %{-p*} %{-P*} \\\
1724 %{MakeOpts} \
1725 %else \
1726 install -d o/include/config \
1727 touch o/include/config/MARKER \
1728 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1729 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1730 %endif \
1731 \
1732 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1733 RCS_FIND_IGNORE="-name '*.[ks]o' -o" \\\
1734 ${1+"$@"} \\\
1735 M=$PWD %{MakeOpts}} \
1736 \
1737 %{__make} -C %{_kernelsrcdir} modules \\\
1738 ${1+"$@"} \\\
1739 M=$PWD CONSTIFY_PLUGIN="" %{MakeOpts} \
1740 \
1741 for MODULE in {%{-m*},}; do \
1742 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1743 done \
1744done \
1745%{?-C:cd -} \
1746} \
1747if [ -r "%{_kernelsrcdir}/.config" ]; then \
1748 compile %{*} \
1749else \
1750 compile_old %{*} \
1751fi \
1752%{nil}
1753
1754
1755# Install kernel modules built by %build_kernel_modules
1756# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1757#
1758# Usage:
1759# %install_kernel_modules -m <modules> -d <directory>
1760#
1761# Options:
1762# -m <modules> (required) -- comma-separated list of modules to install,
1763# without .ko extension, may be placed in subdirectory
1764# -d <directory> (required) -- in what subdirectory modules should be
1765# installed (eg. misc, kernel/drivers/net)
1766# -s <suffix> -- suffix to use when installing modules, useful when module
1767# with same name exists in kernel already
1768# -n <file> -- name of modprobe config file to use (without .conf extension)
1769# for defining aliases, only useful with -s
1770
1771%install_kernel_modules(m:d:s:n:) \
1772%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1773%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1774%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1775 \
1776%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1777%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1778 \
1779__install_kernel_modules() { \
1780%{!?debug:set +x;} \
1781 \
1782for MODULE in {%{-m*},}; do \
1783 [ -n "${MODULE}" ] || continue \
1784 MNAME=${MODULE##*/} \
1785 install -D ${MODULE}.ko %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1786 %{?-s:install -d %{ModprobeD} \
1787 echo "alias ${MNAME} ${MNAME}-%{-s*}" >> %{ModprobeD}/%{-n*}.conf} \
1788done \
1789} \
1790__install_kernel_modules_old() { \
1791%{!?debug:set +x;} \
1792local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1793 \
1794for MODULE in {%{-m*},}; do \
1795 [ -n "${MODULE}" ] || continue \
1796 for cfg in ${cfgs:-dist}; do \
1797 [ "$cfg" = smp ] && suf=smp || suf= \
1798 MNAME=${MODULE##*/} \
1799 install -D ${MODULE}-$cfg.ko \\\
1800 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1801 %{?-s:install -d %{ModprobeD}$suf \
1802 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1803 >> %{ModprobeD}$suf/%{-n*}.conf} \
1804 done \
1805done \
1806} \
1807if [ -r "%{_kernelsrcdir}/.config" ]; then \
1808 __install_kernel_modules \
1809else \
1810 __install_kernel_modules_old \
1811fi \
1812%{nil}
1813
1814# patchset macros
1815# Author: Elan Ruusamäe <glen@pld-linux.org>
1816#
1817# Usage:
1818# %patchset_source -f <seq(1) format> <start> [<end>]
1819# %patchset_patch <start> [<end>]
1820#
1821# If <end> is omited, it is assumed to be <start>.
1822#
1823# For example in preamble:
1824# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1825# and in %prep:
1826# %patchset_patch 33 44
1827
1828# generate SourceX urls from range START STOP
1829# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1830# The sources start from 10000
1831%patchset_source(f:b:) %(
1832 base=%{-b*}%{!-b*:10000};
1833 start=$(expr $base + %1);
1834 end=$(expr $base + %{?2}%{!?2:%{1}});
1835 # we need to call seq twice as it doesn't allow two formats
1836 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1837 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1838 paste %{tmpdir}/__ps{1,2};
1839 rm -f %{tmpdir}/__ps{1,2};
1840) \
1841%{nil}
1842
1843# apply sources from %patchset_source
1844# -p specify -pX for %patch line
1845# -b base offset: defaults to 10000
1846%patchset_patch(f:p:b:) %(
1847 base=%{-b*}%{!-b*:10000};
1848 start=$(expr $base + %1);
1849 end=$(expr $base + %{?2}%{!?2:%{1}});
1850 echo ": patchset_patch %1%{?2: to %2}";
1851 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1852) \
1853%{nil}
1854
1855# return EXPANDED source url N from current spec
1856%sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1857
1858# browser plugins v2
1859# Author: Elan Ruusamäe <glen@pld-linux.org>
1860#
1861# Usage:
1862# %browser_plugins_add_browser <name> -p <plugindir>
1863#
1864# <name> (required) -- name of the browser. usually %{name}.
1865# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1866# -b -- default blacklists
1867# -a <arch> override arch
1868#
1869# Example:
1870# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1871
1872%_browserpluginsconfdir /etc/browser-plugins
1873%_browserpluginsdir %{_libdir}/browser-plugins
1874%update_browser_plugins /usr/sbin/update-browser-plugins || :
1875
1876%browser_plugins_add_browser(p:b:a:) \
1877 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1878 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1879 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1880 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1881 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1882 %{-b:cat >> $blacklist_file %{-b*}} \
1883%{nil}
1884
1885# Helper for LUA.
1886# split string separated by space into quoted list
1887#
1888# Author: Elan Ruusamäe <glen@pld-linux.org>
1889#
1890# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1891%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1892
1893# adjust /etc/shells by adding and removing shells from there
1894# Author: Elan Ruusamäe <glen@pld-linux.org>
1895#
1896# Usage:
1897# %post -p <lua>
1898# %lua_add_etc_shells /bin/sh /bin/pdksh
1899#
1900# %preun -p <lua>
1901# if arg[2] == 0 then
1902# %lua_remove_etc_shells /bin/bash /bin/rbash
1903# end
1904#
1905# Requirements:
1906# BuildRequires: rpmbuild(macros) >= 1.462
1907#
1908
1909%lua_add_etc_shells() \
1910t = {}\
1911f = io.open("/etc/shells", "r")\
1912if f then\
1913 for l in f:lines() do t[l]=l; end\
1914 f:close()\
1915end\
1916for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1917 if not t[s] then\
1918 print("Adding "..s.." to /etc/shells")\
1919 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1920 end\
1921end\
1922%{nil}
1923
1924%lua_remove_etc_shells() \
1925t = {}\
1926f = io.open("/etc/shells", "r")\
1927if f then\
1928 for l in f:lines() do t[l]=l; end\
1929 f:close()\
1930end\
1931for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1932 print("Removing "..l.." from /etc/shells")\
1933 t[l] = nil\
1934end\
1935s=""\
1936for _, l in pairs(t) do\
1937 s=s..l.."\\n"\
1938end\
1939io.open("/etc/shells", "w"):write(s)\
1940%{nil}
1941
1942# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1943#
1944# Author: Elan Ruusamäe <glen@pld-linux.org>
1945#
1946# Usage:
1947# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1948# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1949#
1950# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1951#
1952# Requirements:
1953# BuildRequires: rpmbuild(macros) >= 1.429
1954#
1955%add_etc_shells(p) %{-p:<lua>}\
1956%{expand:%%lua_add_etc_shells %*}\
1957%{nil}
1958
1959%remove_etc_shells(p) %{-p:<lua>}\
1960%{-p:if arg[2] == 0 then}\
1961%{expand:%%lua_remove_etc_shells %*}\
1962%{-p:end} \
1963%{nil}
1964
1965# Check syntax for Python files
1966#
1967# Author: Elan Ruusamäe <glen@pld-linux.org>
1968# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1969#
1970# Usage:
1971# %py_lint src
1972#
1973# Requirements:
1974# BuildRequires: python
1975# BuildRequires: rpmbuild(macros) >= 1.602
1976
1977%py_lint() \
1978__py_lint() { \
1979%{!?debug:set +x;} \
1980find "$@" -type f -name '*.py' | python -c ' \
1981import sys \
1982import compiler \
1983\
1984found = err = 0\
1985for f in sys.stdin: \
1986 fd = open(f.rstrip()) \
1987 c = fd.read() \
1988 fd.close() \
1989 found = found + 1 \
1990 try: \
1991 compiler.parse(c) \
1992 except SyntaxError, e: \
1993 print "py_lint: %s: %s" % (f.rstrip(), e) \
1994 err = err + 1\
1995\
1996if not found:\
1997 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
1998 sys.exit(1) \
1999elif err: \
2000 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
2001 sys.exit(1) \
2002else: \
2003 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
2004' \
2005}; __py_lint %* \
2006%{nil}
2007
2008# Undos files
2009#
2010# Author: Paweł Zuzelski <pawelz@pld-linux.org>
2011# Author: Elan Ruusamäe <glen@pld-linux.org>
2012#
2013# Usage:
2014# %undos list_of_files
2015# %undos -f EXT[,EXT]
2016# %undos -i -f EXT[,EXT]
2017#
2018# -f EXT[,EXT] - find(1) files by extensions
2019# -i - case insensitive file search
2020#
2021# Example:
2022# Un-DOS all *.js, *.css files
2023# %undos -f js,css
2024# Un-DOS all *.js, *.JS files
2025# %undos -f js -i
2026# undos all Makefiles
2027# %{__find} -name Makefile | xargs %undos
2028#
2029# Requirements:
2030# BuildRequires: sed >= 4.0
2031# BuildRequires: rpmbuild(macros) >= 1.565
2032
2033# NB: make sure this macro stays on one line
2034# NB: make sure it includes newline escape
2035%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
2036%{nil}
2037
2038# Hook to register nagios object based plugins in Nagios NRPE daemon config.
2039#
2040# Author: Elan Ruusamäe <glen@pld-linux.org>
2041#
2042# Usage:
2043# -a NAME -- add command named NAME
2044# -d NAME -- remove command named NAME
2045# -f FILE -- specify plugin configuration FILE to extract command definition from
2046#
2047# Sample:
2048# %triggerin -- nagios-nrpe
2049# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2050#
2051# %triggerun -- nagios-nrpe
2052# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2053#
2054# Requirements:
2055# Requires: grep
2056# Requires: sed >= 4.0
2057# BuildRequires: rpmbuild(macros) >= 1.552
2058%nagios_nrpe(a:d:c:f:) {\
2059 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2060 %{-a:# on -a and config exists \
2061 if [ -f /etc/nagios/nrpe.cfg ]; then \
2062 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
2063 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2064 fi; \
2065 fi;} \
2066 %{-d:# on package remove, -d and config exists \
2067 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
2068 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2069 fi;} \
2070 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
2071 %service -q nrpe restart; \
2072 fi; \
2073}%{nil}
2074
2075# Import or update Cacti template.
2076#
2077# Author: Elan Ruusamäe <glen@pld-linux.org>
2078#
2079# Usage:
2080# %cacti_import_template XMLFILE
2081# XMLFILE -- XML template to import
2082#
2083# Sample:
2084# %post
2085# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
2086#
2087# Requires: cacti >= 0.8.7e-8
2088# BuildRequires: rpmbuild(macros) >= 1.630
2089# Note: 1.1 (cacti-0.8.7h) adds requirement for --with-template-rras or --with-user-rras option
2090
2091%cacti_import_template() {\
2092v=$(%{__sed} -rne 's/.+Add Graphs Script ([0-9\.]+).+/\1/p' /usr/share/cacti/cli/import_template.php); \
2093if [ "$v" != "1.0" ]; then \
2094 rra="--with-template-rras"; \
2095fi; \
2096/usr/share/cacti/cli/import_template.php --filename=%1 $rra || :; \
2097}%{nil}
2098
2099# pre/post script for -upstart subpackages
2100#
2101# Author: Jacek Konieczny <jajcus@jajcus.net>
2102#
2103# Usage:
2104# %upstart_post service_name
2105# %upstart_postun service_name
2106#
2107# Sample:
2108# %post upstart
2109# %upstart_post %{name}
2110#
2111# %postun upstart
2112# %upstart_postun %{name}
2113#
2114# Requirements:
2115# BuildRequires: rpmbuild(macros) >= 1.560
2116# Requires: rc-scripts >= 0.4.3
2117
2118# migrate from init script to upstart job
2119%upstart_post() \
2120 if [ -f /var/lock/subsys/%1 ]; then \
2121 /sbin/service --no-upstart %1 stop \
2122 /sbin/service %1 start \
2123 fi
2124
2125# restart the job after upgrade or migrate to init script on removal
2126# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2127# at this point
2128%upstart_postun() \
2129 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2130 /sbin/initctl stop %1 >/dev/null 2>&1 \
2131 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2132 fi
2133
2134# Haskell Macros
2135# BuildRequires: rpmbuild(macros) >= 1.608
2136%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2137
2138# update /usr/lib*/ghc-*/package.conf.d/package.cache
2139# Requires: ghc
2140# BuildRequires: rpmbuild(macros) >= 1.607
2141#
2142%ghc_pkg_recache() {{ \
2143 umask 022; \
2144 /usr/bin/ghc-pkg recache; \
2145};} \
2146%{nil}
2147
2148
2149# pre/post script for packages supporting systemd units
2150#
2151# Author: Bartlomiej Zimon <uzi18@o2.pl>
2152# Jan Rękorajski <baggins@mimuw.edu.pl>
2153#
2154# Usage:
2155# %systemd_reload
2156# %systemd_service <unit command> service_name1.service service_name2.service
2157# %systemd_service_enable service_name1.service service_name2.service
2158# %systemd_service_disable service_name1.service service_name2.service
2159# %systemd_service_start service_name1.service service_name2.service
2160# %systemd_service_stop service_name1.service service_name2.service
2161# %systemd_service_restart service_name1.service service_name2.service
2162# %systemd_service_reload service_name1.service service_name2.service
2163#
2164# %systemd_post service_name1.service service_name2.service
2165# %systemd_preun service_name1.service service_name2.service
2166# %systemd_trigger service_name1.service service_name2.service
2167#
2168# Sample:
2169# %post
2170# %systemd_post %{name}.service
2171#
2172# %preun
2173# %systemd_preun %{name}.service
2174#
2175# %postun
2176# %systemd_reload
2177#
2178# %triggerpostun -- %{name} < first-version-with-systemd-units
2179# %systemd_trigger %{name}.service
2180#
2181# Requirements:
2182# BuildRequires: rpmbuild(macros) >= 1.647
2183# Requires: systemd-units >= 38
2184
2185%systemd_reload /bin/systemd_booted && SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog /bin/systemctl --quiet daemon-reload || :
2186
2187%systemd_service_enable() \
2188 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2189 /bin/systemctl --quiet enable %{*} || : \
2190 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2191%{nil}
2192
2193%systemd_service_disable() \
2194 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2195 /bin/systemctl --quiet disable %{*} || : \
2196%{nil}
2197
2198%systemd_service() \
2199 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2200 /bin/systemd_booted && /bin/systemctl --quiet %{*} || : \
2201%{nil}
2202
2203%systemd_service_start() \
2204 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2205 /bin/systemd_booted && /bin/systemctl --quiet start %{*} || : \
2206%{nil}
2207
2208%systemd_service_stop() \
2209 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2210 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2211%{nil}
2212
2213%systemd_service_restart() \
2214 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2215 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2216%{nil}
2217
2218%systemd_service_reload() \
2219 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2220 /bin/systemd_booted && /bin/systemctl --quiet reload %{*} || : \
2221%{nil}
2222
2223%systemd_trigger() \
2224want_enable_service() { \
2225 [ -f /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
2226 [ ${RPM_ENABLE_SYSTEMD_SERVICE:-yes} = no ] && return 1 \
2227 /sbin/chkconfig --list ${1%.service} 2>/dev/null | grep -qsv "[0-6]:on" && return 1 \
2228 return 0 \
2229}\
2230 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2231 for s in %{*}; do \
2232 if want_enable_service $s; then \
2233 /bin/systemctl --quiet enable $s || : \
2234 fi \
2235 done \
2236%{nil}
2237
2238%systemd_post() \
2239 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2240 /bin/systemd_booted && /bin/systemctl --quiet daemon-reload || : \
2241 if [ $1 -eq 1 ]; then \
2242 /bin/systemctl --quiet enable %{*} || : \
2243 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2244 elif [ -z "$NORESTART" ]; then \
2245 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2246 else \
2247 /bin/systemd_booted && echo 'Run "/bin/systemctl restart %{*}" to restart %{*}.' || : \
2248 fi \
2249%{nil}
2250
2251%systemd_preun() \
2252 if [ $1 -eq 0 ]; then \
2253 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2254 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2255 /bin/systemctl --quiet disable %{*} || : \
2256 fi \
2257%{nil}
2258
2259%systemdunitdir /lib/systemd/system
2260%systemdtmpfilesdir /usr/lib/tmpfiles.d
2261
2262# EOF
This page took 0.067305 seconds and 4 git commands to generate.